



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python 动态创建函数【转】</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python 动态创建函数【转】</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 06:25:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="https://www.zhihu.com/question/38766472" rel="external nofollow noreferrer">知乎上也有相似的问题</a></p>
<p>偶然碰到一个问题，初想是通过动态创建Python函数的方式来解决，于是调研了动态创建Python函数的方法。</p>
<h2>定义lambda函数</h2>
<p>在Python中定义lambda函数的写法很简单，</p>
<div>
<pre class="prettyprint linenums">func = lambda: "foobar"</pre>
</div>
<p>可以认为lambda函数是最常用的一种方式。</p>
<h2>定义局部函数</h2>
<p>Python中函数可以在代码块中进行定义，比如decorator就是通过这种方式实现的，</p>
<div>
<pre class="prettyprint linenums">def decorator(func):<br />
    def _(*args, **kwargs):<br />
        return func(*args, **kwargs)<br />
    return _</pre>
</div>
<h2>通过types.FunctionType创建函数</h2>
<p>Python标准库中的types.FunctionType也可以用于创建函数，常见有如下两种使用方式，</p>
<ul><li>从已有函数构建心函数</li></ul>
<div>
<div>
<pre class="prettyprint linenums">def foobar():<br />
    return "foobar"

dynamic = types.FunctionType(foobar.__code__, {})</pre>
</div>
</div>
<ul><li>配合compile函数构建</li></ul>
<div>
<div>
<pre class="prettyprint linenums">module_code = compile('def foobar(): return "foobar"', '', 'exec')<br />
function_code = [c for c in module_code.co_consts if isinstance(c, types.CodeType)][0]<br />
foobar = types.FunctionType(function_code, {})<br />
print foobar()</pre>
</div>
</div>
<h2>通过ast创建函数</h2>
<p>除了通过compile()直接编译字符串代码之外，Python中也可以直接创建ast相关对象，最终再通过compile(), types.FunctionType进行构建，</p>
<div>
<div>
<pre class="prettyprint linenums">from ast import *<br />
import types

function_ast = FunctionDef(<br />
    name='foobar',<br />
    args=arguments(args=[], vararg=None, kwarg=None, defaults=[]),<br />
    body=[Return(value=Num(n=42, lineno=1, col_offset=0), lineno=1, col_offset=0)],<br />
    decorator_list=[],<br />
    lineno=1,<br />
    col_offset=0<br />
)<br />
module_ast = Module(body=[function_ast])<br />
module_code = compile(module_ast, "&lt;&gt;", "exec")<br />
function_code = [c for c in module_code.co_consts if isinstance(c, types.CodeType)][0]<br />
foobar = types.FunctionType(function_code, {})<br />
print foobar()</pre>
</div>
</div>
<h2>通过eval创建函数</h2>
<p>最后还有一个eval函数，</p>
<div>
<div>
<pre class="prettyprint linenums">foobar = eval('lambda: "foobar"')</pre>
</div>
</div>
<p>在eval函数中不能直接通过def定义函数，所以尝试定义lambda函数进行替代。</p>
<h2>其它方法</h2>
<p>除了上面罗列的还有些旁的方法，比如，</p>
<p>将函数定义写入到单独的py文件中，而后通过 __import__ 操作导入模块来获取定义的函数。</p>
<h2>总结</h2>
<p>绝大部分应用场景下通过lambda或decorator就足以应付需求了，不过动态语言的函数就是真的想动态的搞，也是能找到方法的。</p>
<p>原文：http://soliloquize.org/2015/07/02/Python动态创建函数的几种方法/</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q262jx9.html">C&num;邮件发送问题（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/4954g20q.html">swift代理使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw6d4r9.html">git常见问题解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvk42yq.html">史上最浅显易懂的Git教程！</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m256kq.html">php5函数库</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xyj708.html">Linux Kernel &OpenCurlyQuote;&sol;bcm&sol;Bcmchar&period;c&rsquo;本地信息泄露漏洞</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmd7469.html">Delphi 类方法和普通方法的区别 &period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x11m09.html">jar包的生成及运行</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm43me9.html">乱七八糟 Nodejs 系列一：试水</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmywmx9.html">用Cookie和Session实现用户登录    函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlje2d69.html">RAR压缩解压命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1l7emq.html">linux字符集介绍及解决中文乱码实战</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zopm4vq.html">jQuery动画使用总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1je3e9.html">lambda 委托 匿名方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwo4gv9.html">signal&lpar;&rpar; 和 sigaction&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j7y65q.html">Python自学&colon;第二章 浮点数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o13z1xq.html">Linux  入侵检测小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll06d1q.html">基于UDP&sol;TCP协议的套接字</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1llk19.html">Porting &period;Net RSA xml keys to Java</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pv66g8.html">python 日期格式</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9pjgn79.html">hibernate&period;cfg&period;xml常见配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdekpx9.html">解决IE浏览器文字上面放无内容的元素选不中的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k1kp79.html">&lbrack;原&rsqb;在GeoServer中为OpenStreetMap数据设置OSM样式</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k1kj79.html">微信小程序-多级联动</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyd64dq.html">&lbrack;LeetCode&rsqb; Add Strings 字符串相加</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxn4v08.html">sql查询慢优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/495xy3m8.html">Android开发 Error&colon;The number of method references in a &period;dex file cannot exceed 64K&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlm7o09.html">Extjs 下拉框显示远程数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8okw519.html">C&num;-WebForm-文件上传-FileUpload控件</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn164x8.html">C&plus;&plus;中new&comma;delete和new&lbrack;&rsqb; &comma;delete&lbrack;&rsqb;的分析</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
